require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_AMMINTRIN_H_INCLUDED)) {
    eval 'sub _AMMINTRIN_H_INCLUDED () {1;}' unless defined(&_AMMINTRIN_H_INCLUDED);
    require 'pmmintrin.ph';
    unless(defined(&__SSE4A__)) {
	eval 'sub __DISABLE_SSE4A__ () {1;}' unless defined(&__DISABLE_SSE4A__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_stream_sd (\'double\' *  &__P,  &__m128d  &__Y) {  &__builtin_ia32_movntsd ( &__P, ( &__v2df)  &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_stream_ss (\'float\' *  &__P,  &__m128  &__Y) {  &__builtin_ia32_movntss ( &__P, ( &__v4sf)  &__Y); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_extract_si64 ( &__m128i  &__X,  &__m128i  &__Y) { ( &__m128i)  &__builtin_ia32_extrq (( &__v2di)  &__X, ( &__v16qi)  &__Y); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_extracti_si64 ( &__m128i  &__X, \'unsigned const int __I\', \'unsigned const int __L\') { ( &__m128i)  &__builtin_ia32_extrqi (( &__v2di)  &__X,  &__I,  &__L); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_extracti_si64 {
	    my($X, $I, $L) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_extrqi (( &__v2di)( &__m128i), , ($L))));
	}' unless defined(&_mm_extracti_si64);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_insert_si64 ( &__m128i  &__X, &__m128i  &__Y) { ( &__m128i)  &__builtin_ia32_insertq (( &__v2di) &__X, ( &__v2di) &__Y); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_inserti_si64( &__m128i  &__X,  &__m128i  &__Y, \'unsigned const int __I\', \'unsigned const int __L\') { ( &__m128i)  &__builtin_ia32_insertqi (( &__v2di) &__X, ( &__v2di) &__Y,  &__I,  &__L); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_inserti_si64 {
	    my($X, $Y, $I, $L) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_insertqi (( &__v2di)( &__m128i)($X), ( &__v2di)( &__m128i), , ($L))));
	}' unless defined(&_mm_inserti_si64);
    }
    if(defined(&__DISABLE_SSE4A__)) {
	undef(&__DISABLE_SSE4A__) if defined(&__DISABLE_SSE4A__);
    }
}
1;
