require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FXSRINTRIN_H_INCLUDED)) {
    eval 'sub _FXSRINTRIN_H_INCLUDED () {1;}' unless defined(&_FXSRINTRIN_H_INCLUDED);
    unless(defined(&__FXSR__)) {
	eval 'sub __DISABLE_FXSR__ () {1;}' unless defined(&__DISABLE_FXSR__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_fxsave ( &void * &__P) {  &__builtin_ia32_fxsave ( &__P); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_fxrstor ( &void * &__P) {  &__builtin_ia32_fxrstor ( &__P); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_fxsave64 ( &void * &__P) {  &__builtin_ia32_fxsave64 ( &__P); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_fxrstor64 ( &void * &__P) {  &__builtin_ia32_fxrstor64 ( &__P); });
	}' unless defined(&__attribute__);
    }
    if(defined(&__DISABLE_FXSR__)) {
	undef(&__DISABLE_FXSR__) if defined(&__DISABLE_FXSR__);
    }
}
1;
