require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <shaintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_SHAINTRIN_H_INCLUDED)) {
    eval 'sub _SHAINTRIN_H_INCLUDED () {1;}' unless defined(&_SHAINTRIN_H_INCLUDED);
    unless(defined(&__SHA__)) {
	eval 'sub __DISABLE_SHA__ () {1;}' unless defined(&__DISABLE_SHA__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_sha1msg1_epu32 ( &__m128i  &__A,  &__m128i  &__B) { ( &__m128i)  &__builtin_ia32_sha1msg1 (( &__v4si)  &__A, ( &__v4si)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_sha1msg2_epu32 ( &__m128i  &__A,  &__m128i  &__B) { ( &__m128i)  &__builtin_ia32_sha1msg2 (( &__v4si)  &__A, ( &__v4si)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_sha1nexte_epu32 ( &__m128i  &__A,  &__m128i  &__B) { ( &__m128i)  &__builtin_ia32_sha1nexte (( &__v4si)  &__A, ( &__v4si)  &__B); });
    }' unless defined(&__attribute__);
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_sha1rnds4_epu32 ( &__m128i  &__A,  &__m128i  &__B,  &const \'int\'  &__I) { ( &__m128i)  &__builtin_ia32_sha1rnds4 (( &__v4si)  &__A, ( &__v4si)  &__B,  &__I); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm_sha1rnds4_epu32 {
	    my($A, $B, $I) = @_;
    	    eval q((( &__m128i)  &__builtin_ia32_sha1rnds4 (( &__v4si)( &__m128i)$A, ( &__v4si)( &__m128i)$B, $I)));
	}' unless defined(&_mm_sha1rnds4_epu32);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_sha256msg1_epu32 ( &__m128i  &__A,  &__m128i  &__B) { ( &__m128i)  &__builtin_ia32_sha256msg1 (( &__v4si)  &__A, ( &__v4si)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_sha256msg2_epu32 ( &__m128i  &__A,  &__m128i  &__B) { ( &__m128i)  &__builtin_ia32_sha256msg2 (( &__v4si)  &__A, ( &__v4si)  &__B); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_sha256rnds2_epu32 ( &__m128i  &__A,  &__m128i  &__B,  &__m128i  &__C) { ( &__m128i)  &__builtin_ia32_sha256rnds2 (( &__v4si)  &__A, ( &__v4si)  &__B, ( &__v4si)  &__C); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_SHA__)) {
	undef(&__DISABLE_SHA__) if defined(&__DISABLE_SHA__);
    }
}
1;
