require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_I386_BYTE_SWAP_H_)) {
    eval 'sub _I386_BYTE_SWAP_H_ () {1;}' unless defined(&_I386_BYTE_SWAP_H_);
    require 'sys/types.ph';
    if(defined(&__GNUC__)) {
	eval 'sub __BYTE_SWAP_U32_VARIABLE () { &__byte_swap_u32_variable;}' unless defined(&__BYTE_SWAP_U32_VARIABLE);
	eval 'sub __byte_swap_u32_variable {
	    my($x) = @_;
    	    eval q({  &__asm  &volatile ( \\"bswap %1\\" : \\"=r\\" ($x) : \\"0\\" ($x)); ($x); });
	}' unless defined(&__byte_swap_u32_variable);
	eval 'sub __BYTE_SWAP_U16_VARIABLE () { &__byte_swap_u16_variable;}' unless defined(&__BYTE_SWAP_U16_VARIABLE);
	eval 'sub __byte_swap_u16_variable {
	    my($x) = @_;
    	    eval q({  &__asm  &volatile (\\"rorw $8, %w1\\" : \\"=r\\" ($x) : \\"0\\" ($x)); ($x); });
	}' unless defined(&__byte_swap_u16_variable);
    }
 elsif(defined(&_KERNEL) || defined(&_LKM)) {
	eval 'sub __BYTE_SWAP_U32_VARIABLE () { &__byte_swap_u32_variable;}' unless defined(&__BYTE_SWAP_U32_VARIABLE);
	eval 'sub __BYTE_SWAP_U16_VARIABLE () { &__byte_swap_u16_variable;}' unless defined(&__BYTE_SWAP_U16_VARIABLE);
    }
}
1;
