require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_I386_VMPARAM_H_)) {
    eval 'sub _I386_VMPARAM_H_ () {1;}' unless defined(&_I386_VMPARAM_H_);
    require 'sys/mutex.ph';
    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    eval 'sub PAGE_SIZE () {(1<<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {( &PAGE_SIZE - 1);}' unless defined(&PAGE_MASK);
    eval 'sub USRSTACK () { &VM_MAXUSER_ADDRESS;}' unless defined(&USRSTACK);
    eval 'sub MAXTSIZ () {(256*1024*1024);}' unless defined(&MAXTSIZ);
    unless(defined(&DFLDSIZ)) {
	eval 'sub DFLDSIZ () {(256*1024*1024);}' unless defined(&DFLDSIZ);
    }
    unless(defined(&MAXDSIZ)) {
	eval 'sub MAXDSIZ () {(3*1024*1024*1024);}' unless defined(&MAXDSIZ);
    }
    unless(defined(&MAXDSIZ_BU)) {
	eval 'sub MAXDSIZ_BU () {(2*1024*1024*1024+ 1* 512*1024*1024);}' unless defined(&MAXDSIZ_BU);
    }
    unless(defined(&DFLSSIZ)) {
	eval 'sub DFLSSIZ () {(2*1024*1024);}' unless defined(&DFLSSIZ);
    }
    unless(defined(&MAXSSIZ)) {
	eval 'sub MAXSSIZ () {(64*1024*1024);}' unless defined(&MAXSSIZ);
    }
    eval 'sub I386_MAX_EXE_ADDR () {( &USRSTACK -  &MAXSSIZ);}' unless defined(&I386_MAX_EXE_ADDR);
    eval 'sub USRIOSIZE () {300;}' unless defined(&USRIOSIZE);
    eval 'sub VM_MIN_ADDRESS () {(( &vaddr_t)0);}' unless defined(&VM_MIN_ADDRESS);
    eval 'sub VM_MAXUSER_ADDRESS () {(( &vaddr_t)( &PDIR_SLOT_PTE <<  &L2_SHIFT) -  &PAGE_SIZE);}' unless defined(&VM_MAXUSER_ADDRESS);
    eval 'sub VM_MAX_ADDRESS () {(( &vaddr_t)(( &PDIR_SLOT_PTE <<  &L2_SHIFT) + ( &PDIR_SLOT_PTE <<  &L1_SHIFT)));}' unless defined(&VM_MAX_ADDRESS);
    eval 'sub VM_MIN_KERNEL_ADDRESS () {(( &vaddr_t)( &PDIR_SLOT_KERN <<  &L2_SHIFT));}' unless defined(&VM_MIN_KERNEL_ADDRESS);
    eval 'sub VM_MAX_KERNEL_ADDRESS () {(( &vaddr_t)(( &PDIR_SLOT_KERN +  &NKL2_MAX_ENTRIES) <<  &L2_SHIFT));}' unless defined(&VM_MAX_KERNEL_ADDRESS);
    if(defined(&_KERNEL_OPT)) {
	require './i386/opt_uvm.ph';
	require './i386/opt_xen.ph';
    }
    eval 'sub __USE_TOPDOWN_VM () {1;}' unless defined(&__USE_TOPDOWN_VM);
    eval 'sub VM_DEFAULT_ADDRESS_BOTTOMUP {
        my($da, $sz) = @_;
	    eval q( &round_page(( &vaddr_t)($da) + ( &vsize_t) &MIN( &maxdmap,  &MAXDSIZ_BU)));
    }' unless defined(&VM_DEFAULT_ADDRESS_BOTTOMUP);
    eval 'sub VM_PHYS_SIZE () {( &USRIOSIZE* &PAGE_SIZE);}' unless defined(&VM_PHYS_SIZE);
    eval 'sub VM_PHYSSEG_STRAT () { &VM_PSTRAT_BIGFIRST;}' unless defined(&VM_PHYSSEG_STRAT);
    if(defined(&XENPV)) {
	eval 'sub VM_PHYSSEG_MAX () {1;}' unless defined(&VM_PHYSSEG_MAX);
	eval 'sub VM_NFREELIST () {1;}' unless defined(&VM_NFREELIST);
    } else {
	eval 'sub VM_PHYSSEG_MAX () {32;}' unless defined(&VM_PHYSSEG_MAX);
	eval 'sub VM_NFREELIST () {4;}' unless defined(&VM_NFREELIST);
	eval 'sub VM_FREELIST_FIRST16 () {3;}' unless defined(&VM_FREELIST_FIRST16);
	eval 'sub VM_FREELIST_FIRST1G () {2;}' unless defined(&VM_FREELIST_FIRST1G);
	eval 'sub VM_FREELIST_FIRST4G () {1;}' unless defined(&VM_FREELIST_FIRST4G);
    }
    eval 'sub VM_FREELIST_DEFAULT () {0;}' unless defined(&VM_FREELIST_DEFAULT);
}
1;
