require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub BTINFO_BOOTPATH () {0;}' unless defined(&BTINFO_BOOTPATH);
eval 'sub BTINFO_ROOTDEVICE () {1;}' unless defined(&BTINFO_ROOTDEVICE);
eval 'sub BTINFO_BOOTDISK () {3;}' unless defined(&BTINFO_BOOTDISK);
eval 'sub BTINFO_NETIF () {4;}' unless defined(&BTINFO_NETIF);
eval 'sub BTINFO_CONSOLE () {6;}' unless defined(&BTINFO_CONSOLE);
eval 'sub BTINFO_BIOSGEOM () {7;}' unless defined(&BTINFO_BIOSGEOM);
eval 'sub BTINFO_SYMTAB () {8;}' unless defined(&BTINFO_SYMTAB);
eval 'sub BTINFO_MEMMAP () {9;}' unless defined(&BTINFO_MEMMAP);
eval 'sub BTINFO_BOOTWEDGE () {10;}' unless defined(&BTINFO_BOOTWEDGE);
eval 'sub BTINFO_MODULELIST () {11;}' unless defined(&BTINFO_MODULELIST);
eval 'sub BTINFO_FRAMEBUFFER () {12;}' unless defined(&BTINFO_FRAMEBUFFER);
eval 'sub BTINFO_USERCONFCOMMANDS () {13;}' unless defined(&BTINFO_USERCONFCOMMANDS);
eval 'sub BTINFO_EFI () {14;}' unless defined(&BTINFO_EFI);
eval 'sub BTINFO_EFIMEMMAP () {15;}' unless defined(&BTINFO_EFIMEMMAP);
eval 'sub BTINFO_PREKERN () {16;}' unless defined(&BTINFO_PREKERN);
eval 'sub BTINFO_STR () {"bootpath", "rootdevice", "bootdisk", "netif", "console", "biosgeom", "symtab", "memmap", "bootwedge", "modulelist", "framebuffer", "userconfcommands", "efi", "efimemmap", "prekern",;}' unless defined(&BTINFO_STR);
unless(defined(&_LOCORE)) {
    eval 'sub BI_BUS_ISA () {0;}' unless defined(&BI_BUS_ISA);
    eval 'sub BI_BUS_PCI () {1;}' unless defined(&BI_BUS_PCI);
    eval 'sub BIM_Memory () {1;}' unless defined(&BIM_Memory);
    eval 'sub BIM_Reserved () {2;}' unless defined(&BIM_Reserved);
    eval 'sub BIM_ACPI () {3;}' unless defined(&BIM_ACPI);
    eval 'sub BIM_NVS () {4;}' unless defined(&BIM_NVS);
    eval 'sub BIM_Unusable () {5;}' unless defined(&BIM_Unusable);
    eval 'sub BIM_Disabled () {6;}' unless defined(&BIM_Disabled);
    eval 'sub BIM_PMEM () {7;}' unless defined(&BIM_PMEM);
    eval 'sub BIM_PRAM () {12;}' unless defined(&BIM_PRAM);
    if((defined(&HAVE_NBTOOL_CONFIG_H) ? &HAVE_NBTOOL_CONFIG_H : undef)) {
	require 'nbinclude/sys/bootblock.ph';
    } else {
	require 'sys/bootblock.ph';
    }
    eval 'sub BI_GEOM_INVALID () {0x1;}' unless defined(&BI_GEOM_INVALID);
    eval 'sub BI_GEOM_EXTINT13 () {0x2;}' unless defined(&BI_GEOM_EXTINT13);
    if(defined(&BIOSDISK_EXTINFO_V3)) {
	eval 'sub BI_GEOM_BADCKSUM () {0x4;}' unless defined(&BI_GEOM_BADCKSUM);
	eval 'sub BI_GEOM_BUS_MASK () {0xff00;}' unless defined(&BI_GEOM_BUS_MASK);
	eval 'sub BI_GEOM_BUS_ISA () {0x100;}' unless defined(&BI_GEOM_BUS_ISA);
	eval 'sub BI_GEOM_BUS_PCI () {0x200;}' unless defined(&BI_GEOM_BUS_PCI);
	eval 'sub BI_GEOM_BUS_OTHER () {0xff00;}' unless defined(&BI_GEOM_BUS_OTHER);
	eval 'sub BI_GEOM_IFACE_MASK () {0xff0000;}' unless defined(&BI_GEOM_IFACE_MASK);
	eval 'sub BI_GEOM_IFACE_ATA () {0x10000;}' unless defined(&BI_GEOM_IFACE_ATA);
	eval 'sub BI_GEOM_IFACE_ATAPI () {0x20000;}' unless defined(&BI_GEOM_IFACE_ATAPI);
	eval 'sub BI_GEOM_IFACE_SCSI () {0x30000;}' unless defined(&BI_GEOM_IFACE_SCSI);
	eval 'sub BI_GEOM_IFACE_USB () {0x40000;}' unless defined(&BI_GEOM_IFACE_USB);
	eval 'sub BI_GEOM_IFACE_1394 () {0x50000;}' unless defined(&BI_GEOM_IFACE_1394);
	eval 'sub BI_GEOM_IFACE_FIBRE () {0x60000;}' unless defined(&BI_GEOM_IFACE_FIBRE);
	eval 'sub BI_GEOM_IFACE_OTHER () {0xff0000;}' unless defined(&BI_GEOM_IFACE_OTHER);
    } else {
    }
    eval 'sub BI_MODULE_NONE () {0x;}' unless defined(&BI_MODULE_NONE);
    eval 'sub BI_MODULE_ELF () {0x1;}' unless defined(&BI_MODULE_ELF);
    eval 'sub BI_MODULE_IMAGE () {0x2;}' unless defined(&BI_MODULE_IMAGE);
    eval 'sub BI_MODULE_RND () {0x3;}' unless defined(&BI_MODULE_RND);
    eval 'sub BI_MODULE_FS () {0x4;}' unless defined(&BI_MODULE_FS);
    eval 'sub BI_EFI_32BIT () { &__BIT(0);}' unless defined(&BI_EFI_32BIT);
}
if(defined(&_KERNEL)) {
    eval 'sub BOOTINFO_MAXSIZE () {16384;}' unless defined(&BOOTINFO_MAXSIZE);
    unless(defined(&_LOCORE)) {
    }
}
1;
