require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_CPU_EXTENDED_STATE_H_)) {
    eval 'sub _X86_CPU_EXTENDED_STATE_H_ () {1;}' unless defined(&_X86_CPU_EXTENDED_STATE_H_);
    if(defined(&__lint__)) {
	eval 'sub __CTASSERT_NOLINT {
	    my($x) = @_;
    	    eval q( &__CTASSERT(1));
	}' unless defined(&__CTASSERT_NOLINT);
    } else {
	eval 'sub __CTASSERT_NOLINT {
	    my($x) = @_;
    	    eval q( &__CTASSERT($x));
	}' unless defined(&__CTASSERT_NOLINT);
    }
    eval 'sub s87_opcode () { ($s87_ip->{fa_32}->{fa_opcode});}' unless defined(&s87_opcode);
    if(defined(&_KERNEL)) {
    }
    eval 'sub EN_SW_INVOP () {0x1;}' unless defined(&EN_SW_INVOP);
    eval 'sub EN_SW_DENORM () {0x2;}' unless defined(&EN_SW_DENORM);
    eval 'sub EN_SW_ZERODIV () {0x4;}' unless defined(&EN_SW_ZERODIV);
    eval 'sub EN_SW_OVERFLOW () {0x8;}' unless defined(&EN_SW_OVERFLOW);
    eval 'sub EN_SW_UNDERFLOW () {0x10;}' unless defined(&EN_SW_UNDERFLOW);
    eval 'sub EN_SW_PRECLOSS () {0x20;}' unless defined(&EN_SW_PRECLOSS);
    eval 'sub EN_SW_STACK_FAULT () {0x40;}' unless defined(&EN_SW_STACK_FAULT);
    eval 'sub EN_SW_ERROR_SUMMARY () {0x80;}' unless defined(&EN_SW_ERROR_SUMMARY);
    eval 'sub EN_SW_CTL_PREC () {0x300;}' unless defined(&EN_SW_CTL_PREC);
    eval 'sub EN_SW_PREC_24 () {0x;}' unless defined(&EN_SW_PREC_24);
    eval 'sub EN_SW_PREC_53 () {0x200;}' unless defined(&EN_SW_PREC_53);
    eval 'sub EN_SW_PREC_64 () {0x300;}' unless defined(&EN_SW_PREC_64);
    eval 'sub EN_SW_CTL_ROUND () {0xc00;}' unless defined(&EN_SW_CTL_ROUND);
    eval 'sub EN_SW_ROUND_EVEN () {0x;}' unless defined(&EN_SW_ROUND_EVEN);
    eval 'sub EN_SW_ROUND_DOWN () {0x400;}' unless defined(&EN_SW_ROUND_DOWN);
    eval 'sub EN_SW_ROUND_UP () {0x800;}' unless defined(&EN_SW_ROUND_UP);
    eval 'sub EN_SW_ROUND_ZERO () {0xc00;}' unless defined(&EN_SW_ROUND_ZERO);
    eval 'sub EN_SW_CTL_INF () {0x1000;}' unless defined(&EN_SW_CTL_INF);
    eval 'sub __INITIAL_NPXCW__ () {0x37f;}' unless defined(&__INITIAL_NPXCW__);
    eval 'sub __NetBSD_NPXCW__ () { &__INITIAL_NPXCW__;}' unless defined(&__NetBSD_NPXCW__);
    eval 'sub __NetBSD_COMPAT_NPXCW__ () {0x127f;}' unless defined(&__NetBSD_COMPAT_NPXCW__);
    eval 'sub __FreeBSD_NPXCW__ () {0x1272;}' unless defined(&__FreeBSD_NPXCW__);
    eval 'sub __Linux_NPXCW__ () { &__INITIAL_NPXCW__;}' unless defined(&__Linux_NPXCW__);
    eval 'sub __INITIAL_MXCSR__ () {0x1f80;}' unless defined(&__INITIAL_MXCSR__);
    eval 'sub __INITIAL_MXCSR_MASK__ () {0xffbf;}' unless defined(&__INITIAL_MXCSR_MASK__);
}
1;
