require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_SYSARCH_H_)) {
    eval 'sub _X86_SYSARCH_H_ () {1;}' unless defined(&_X86_SYSARCH_H_);
    eval 'sub X86_GET_LDT () {0;}' unless defined(&X86_GET_LDT);
    eval 'sub X86_SET_LDT () {1;}' unless defined(&X86_SET_LDT);
    eval 'sub X86_IOPL () {2;}' unless defined(&X86_IOPL);
    eval 'sub X86_GET_IOPERM () {3;}' unless defined(&X86_GET_IOPERM);
    eval 'sub X86_SET_IOPERM () {4;}' unless defined(&X86_SET_IOPERM);
    eval 'sub X86_OLD_VM86 () {5;}' unless defined(&X86_OLD_VM86);
    eval 'sub X86_GET_MTRR () {11;}' unless defined(&X86_GET_MTRR);
    eval 'sub X86_SET_MTRR () {12;}' unless defined(&X86_SET_MTRR);
    eval 'sub X86_VM86 () {13;}' unless defined(&X86_VM86);
    eval 'sub X86_GET_GSBASE () {14;}' unless defined(&X86_GET_GSBASE);
    eval 'sub X86_GET_FSBASE () {15;}' unless defined(&X86_GET_FSBASE);
    eval 'sub X86_SET_GSBASE () {16;}' unless defined(&X86_SET_GSBASE);
    eval 'sub X86_SET_FSBASE () {17;}' unless defined(&X86_SET_FSBASE);
    if(defined(&_KERNEL)) {
	eval 'sub _X86_SYSARCH_L {
	    my($x) = @_;
    	    eval q( &x86_$x);
	}' unless defined(&_X86_SYSARCH_L);
	eval 'sub _X86_SYSARCH_U {
	    my($x) = @_;
    	    eval q( &X86_$x);
	}' unless defined(&_X86_SYSARCH_U);
    }
 elsif(defined(&__i386__)) {
	eval 'sub _X86_SYSARCH_L {
	    my($x) = @_;
    	    eval q( &i386_$x);
	}' unless defined(&_X86_SYSARCH_L);
	eval 'sub _X86_SYSARCH_U {
	    my($x) = @_;
    	    eval q( &I386_$x);
	}' unless defined(&_X86_SYSARCH_U);
	eval 'sub I386_GET_LDT () { &X86_GET_LDT;}' unless defined(&I386_GET_LDT);
	eval 'sub I386_SET_LDT () { &X86_SET_LDT;}' unless defined(&I386_SET_LDT);
	eval 'sub I386_IOPL () { &X86_IOPL;}' unless defined(&I386_IOPL);
	eval 'sub I386_GET_IOPERM () { &X86_GET_IOPERM;}' unless defined(&I386_GET_IOPERM);
	eval 'sub I386_SET_IOPERM () { &X86_SET_IOPERM;}' unless defined(&I386_SET_IOPERM);
	eval 'sub I386_OLD_VM86 () { &X86_OLD_VM86;}' unless defined(&I386_OLD_VM86);
	eval 'sub I386_GET_MTRR () { &X86_GET_MTRR;}' unless defined(&I386_GET_MTRR);
	eval 'sub I386_SET_MTRR () { &X86_SET_MTRR;}' unless defined(&I386_SET_MTRR);
	eval 'sub I386_VM86 () { &X86_VM86;}' unless defined(&I386_VM86);
	eval 'sub I386_GET_GSBASE () { &X86_GET_GSBASE;}' unless defined(&I386_GET_GSBASE);
	eval 'sub I386_GET_FSBASE () { &X86_GET_FSBASE;}' unless defined(&I386_GET_FSBASE);
	eval 'sub I386_SET_GSBASE () { &X86_SET_GSBASE;}' unless defined(&I386_SET_GSBASE);
	eval 'sub I386_SET_FSBASE () { &X86_SET_FSBASE;}' unless defined(&I386_SET_FSBASE);
    } else {
	eval 'sub _X86_SYSARCH_L {
	    my($x) = @_;
    	    eval q( &x86_64_$x);
	}' unless defined(&_X86_SYSARCH_L);
	eval 'sub _X86_SYSARCH_U {
	    my($x) = @_;
    	    eval q( &X86_64_$x);
	}' unless defined(&_X86_SYSARCH_U);
	eval 'sub X86_64_GET_LDT () { &X86_GET_LDT;}' unless defined(&X86_64_GET_LDT);
	eval 'sub X86_64_SET_LDT () { &X86_SET_LDT;}' unless defined(&X86_64_SET_LDT);
	eval 'sub X86_64_IOPL () { &X86_IOPL;}' unless defined(&X86_64_IOPL);
	eval 'sub X86_64_GET_IOPERM () { &X86_GET_IOPERM;}' unless defined(&X86_64_GET_IOPERM);
	eval 'sub X86_64_SET_IOPERM () { &X86_SET_IOPERM;}' unless defined(&X86_64_SET_IOPERM);
	eval 'sub X86_64_OLD_VM86 () { &X86_OLD_VM86;}' unless defined(&X86_64_OLD_VM86);
	eval 'sub X86_64_GET_MTRR () { &X86_GET_MTRR;}' unless defined(&X86_64_GET_MTRR);
	eval 'sub X86_64_SET_MTRR () { &X86_SET_MTRR;}' unless defined(&X86_64_SET_MTRR);
	eval 'sub X86_64_VM86 () { &X86_VM86;}' unless defined(&X86_64_VM86);
	eval 'sub X86_64_GET_GSBASE () { &X86_GET_GSBASE;}' unless defined(&X86_64_GET_GSBASE);
	eval 'sub X86_64_GET_FSBASE () { &X86_GET_FSBASE;}' unless defined(&X86_64_GET_FSBASE);
	eval 'sub X86_64_SET_GSBASE () { &X86_SET_GSBASE;}' unless defined(&X86_64_SET_GSBASE);
	eval 'sub X86_64_SET_FSBASE () { &X86_SET_FSBASE;}' unless defined(&X86_64_SET_FSBASE);
    }
    if(defined(&_KERNEL)) {
    } else {
	require 'sys/cdefs.ph';
    }
}
1;
