require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512erintrin.h> directly; include <immintrin.h> instead.");
}
unless(defined(&_AVX512ERINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512ERINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512ERINTRIN_H_INCLUDED);
    unless(defined(&__AVX512ER__)) {
	eval 'sub __DISABLE_AVX512ER__ () {1;}' unless defined(&__DISABLE_AVX512ER__);
    }
    if(defined(&__OPTIMIZE__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_exp2a23_round_pd ( &__m512d  &__A, \'int\'  &__R) {  &__m512d  &__W; ( &__m512d)  &__builtin_ia32_exp2pd_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_exp2a23_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A, \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_exp2pd_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_exp2a23_round_pd ( &__mmask8  &__U,  &__m512d  &__A, \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_exp2pd_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_exp2a23_round_ps ( &__m512  &__A, \'int\'  &__R) {  &__m512  &__W; ( &__m512)  &__builtin_ia32_exp2ps_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_exp2a23_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A, \'int\'  &__R) { ( &__m512)  &__builtin_ia32_exp2ps_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_exp2a23_round_ps ( &__mmask16  &__U,  &__m512  &__A, \'int\'  &__R) { ( &__m512)  &__builtin_ia32_exp2ps_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rcp28_round_pd ( &__m512d  &__A, \'int\'  &__R) {  &__m512d  &__W; ( &__m512d)  &__builtin_ia32_rcp28pd_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rcp28_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A, \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_rcp28pd_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rcp28_round_pd ( &__mmask8  &__U,  &__m512d  &__A, \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_rcp28pd_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rcp28_round_ps ( &__m512  &__A, \'int\'  &__R) {  &__m512  &__W; ( &__m512)  &__builtin_ia32_rcp28ps_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rcp28_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A, \'int\'  &__R) { ( &__m512)  &__builtin_ia32_rcp28ps_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rcp28_round_ps ( &__mmask16  &__U,  &__m512  &__A, \'int\'  &__R) { ( &__m512)  &__builtin_ia32_rcp28ps_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_rcp28_round_sd ( &__m128d  &__A,  &__m128d  &__B, \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_rcp28sd_round (( &__v2df)  &__B, ( &__v2df)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_rcp28_round_ss ( &__m128  &__A,  &__m128  &__B, \'int\'  &__R) { ( &__m128)  &__builtin_ia32_rcp28ss_round (( &__v4sf)  &__B, ( &__v4sf)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rsqrt28_round_pd ( &__m512d  &__A, \'int\'  &__R) {  &__m512d  &__W; ( &__m512d)  &__builtin_ia32_rsqrt28pd_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rsqrt28_round_pd ( &__m512d  &__W,  &__mmask8  &__U,  &__m512d  &__A, \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_rsqrt28pd_mask (( &__v8df)  &__A, ( &__v8df)  &__W, ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rsqrt28_round_pd ( &__mmask8  &__U,  &__m512d  &__A, \'int\'  &__R) { ( &__m512d)  &__builtin_ia32_rsqrt28pd_mask (( &__v8df)  &__A, ( &__v8df)  &_mm512_setzero_pd (), ( &__mmask8)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_rsqrt28_round_ps ( &__m512  &__A, \'int\'  &__R) {  &__m512  &__W; ( &__m512)  &__builtin_ia32_rsqrt28ps_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16) -1,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_rsqrt28_round_ps ( &__m512  &__W,  &__mmask16  &__U,  &__m512  &__A, \'int\'  &__R) { ( &__m512)  &__builtin_ia32_rsqrt28ps_mask (( &__v16sf)  &__A, ( &__v16sf)  &__W, ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_rsqrt28_round_ps ( &__mmask16  &__U,  &__m512  &__A, \'int\'  &__R) { ( &__m512)  &__builtin_ia32_rsqrt28ps_mask (( &__v16sf)  &__A, ( &__v16sf)  &_mm512_setzero_ps (), ( &__mmask16)  &__U,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_rsqrt28_round_sd ( &__m128d  &__A,  &__m128d  &__B, \'int\'  &__R) { ( &__m128d)  &__builtin_ia32_rsqrt28sd_round (( &__v2df)  &__B, ( &__v2df)  &__A,  &__R); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_rsqrt28_round_ss ( &__m128  &__A,  &__m128  &__B, \'int\'  &__R) { ( &__m128)  &__builtin_ia32_rsqrt28ss_round (( &__v4sf)  &__B, ( &__v4sf)  &__A,  &__R); });
	}' unless defined(&__attribute__);
    } else {
	eval 'sub _mm512_exp2a23_round_pd {
	    my($A, $C) = @_;
    	    eval q( &__builtin_ia32_exp2pd_mask($A, ( &__v8df) &_mm512_setzero_pd(), -1, $C));
	}' unless defined(&_mm512_exp2a23_round_pd);
	eval 'sub _mm512_mask_exp2a23_round_pd {
	    my($W, $U, $A, $C) = @_;
    	    eval q( &__builtin_ia32_exp2pd_mask($A, $W, $U, $C));
	}' unless defined(&_mm512_mask_exp2a23_round_pd);
	eval 'sub _mm512_maskz_exp2a23_round_pd {
	    my($U, $A, $C) = @_;
    	    eval q( &__builtin_ia32_exp2pd_mask($A, ( &__v8df) &_mm512_setzero_pd(), $U, $C));
	}' unless defined(&_mm512_maskz_exp2a23_round_pd);
	eval 'sub _mm512_exp2a23_round_ps {
	    my($A, $C) = @_;
    	    eval q( &__builtin_ia32_exp2ps_mask($A, ( &__v16sf) &_mm512_setzero_ps(), -1, $C));
	}' unless defined(&_mm512_exp2a23_round_ps);
	eval 'sub _mm512_mask_exp2a23_round_ps {
	    my($W, $U, $A, $C) = @_;
    	    eval q( &__builtin_ia32_exp2ps_mask($A, $W, $U, $C));
	}' unless defined(&_mm512_mask_exp2a23_round_ps);
	eval 'sub _mm512_maskz_exp2a23_round_ps {
	    my($U, $A, $C) = @_;
    	    eval q( &__builtin_ia32_exp2ps_mask($A, ( &__v16sf) &_mm512_setzero_ps(), $U, $C));
	}' unless defined(&_mm512_maskz_exp2a23_round_ps);
	eval 'sub _mm512_rcp28_round_pd {
	    my($A, $C) = @_;
    	    eval q( &__builtin_ia32_rcp28pd_mask($A, ( &__v8df) &_mm512_setzero_pd(), -1, $C));
	}' unless defined(&_mm512_rcp28_round_pd);
	eval 'sub _mm512_mask_rcp28_round_pd {
	    my($W, $U, $A, $C) = @_;
    	    eval q( &__builtin_ia32_rcp28pd_mask($A, $W, $U, $C));
	}' unless defined(&_mm512_mask_rcp28_round_pd);
	eval 'sub _mm512_maskz_rcp28_round_pd {
	    my($U, $A, $C) = @_;
    	    eval q( &__builtin_ia32_rcp28pd_mask($A, ( &__v8df) &_mm512_setzero_pd(), $U, $C));
	}' unless defined(&_mm512_maskz_rcp28_round_pd);
	eval 'sub _mm512_rcp28_round_ps {
	    my($A, $C) = @_;
    	    eval q( &__builtin_ia32_rcp28ps_mask($A, ( &__v16sf) &_mm512_setzero_ps(), -1, $C));
	}' unless defined(&_mm512_rcp28_round_ps);
	eval 'sub _mm512_mask_rcp28_round_ps {
	    my($W, $U, $A, $C) = @_;
    	    eval q( &__builtin_ia32_rcp28ps_mask($A, $W, $U, $C));
	}' unless defined(&_mm512_mask_rcp28_round_ps);
	eval 'sub _mm512_maskz_rcp28_round_ps {
	    my($U, $A, $C) = @_;
    	    eval q( &__builtin_ia32_rcp28ps_mask($A, ( &__v16sf) &_mm512_setzero_ps(), $U, $C));
	}' unless defined(&_mm512_maskz_rcp28_round_ps);
	eval 'sub _mm512_rsqrt28_round_pd {
	    my($A, $C) = @_;
    	    eval q( &__builtin_ia32_rsqrt28pd_mask($A, ( &__v8df) &_mm512_setzero_pd(), -1, $C));
	}' unless defined(&_mm512_rsqrt28_round_pd);
	eval 'sub _mm512_mask_rsqrt28_round_pd {
	    my($W, $U, $A, $C) = @_;
    	    eval q( &__builtin_ia32_rsqrt28pd_mask($A, $W, $U, $C));
	}' unless defined(&_mm512_mask_rsqrt28_round_pd);
	eval 'sub _mm512_maskz_rsqrt28_round_pd {
	    my($U, $A, $C) = @_;
    	    eval q( &__builtin_ia32_rsqrt28pd_mask($A, ( &__v8df) &_mm512_setzero_pd(), $U, $C));
	}' unless defined(&_mm512_maskz_rsqrt28_round_pd);
	eval 'sub _mm512_rsqrt28_round_ps {
	    my($A, $C) = @_;
    	    eval q( &__builtin_ia32_rsqrt28ps_mask($A, ( &__v16sf) &_mm512_setzero_ps(), -1, $C));
	}' unless defined(&_mm512_rsqrt28_round_ps);
	eval 'sub _mm512_mask_rsqrt28_round_ps {
	    my($W, $U, $A, $C) = @_;
    	    eval q( &__builtin_ia32_rsqrt28ps_mask($A, $W, $U, $C));
	}' unless defined(&_mm512_mask_rsqrt28_round_ps);
	eval 'sub _mm512_maskz_rsqrt28_round_ps {
	    my($U, $A, $C) = @_;
    	    eval q( &__builtin_ia32_rsqrt28ps_mask($A, ( &__v16sf) &_mm512_setzero_ps(), $U, $C));
	}' unless defined(&_mm512_maskz_rsqrt28_round_ps);
	eval 'sub _mm_rcp28_round_sd {
	    my($A, $B, $R) = @_;
    	    eval q( &__builtin_ia32_rcp28sd_round($A, $B, $R));
	}' unless defined(&_mm_rcp28_round_sd);
	eval 'sub _mm_rcp28_round_ss {
	    my($A, $B, $R) = @_;
    	    eval q( &__builtin_ia32_rcp28ss_round($A, $B, $R));
	}' unless defined(&_mm_rcp28_round_ss);
	eval 'sub _mm_rsqrt28_round_sd {
	    my($A, $B, $R) = @_;
    	    eval q( &__builtin_ia32_rsqrt28sd_round($A, $B, $R));
	}' unless defined(&_mm_rsqrt28_round_sd);
	eval 'sub _mm_rsqrt28_round_ss {
	    my($A, $B, $R) = @_;
    	    eval q( &__builtin_ia32_rsqrt28ss_round($A, $B, $R));
	}' unless defined(&_mm_rsqrt28_round_ss);
    }
    eval 'sub _mm512_exp2a23_pd {
        my($A) = @_;
	    eval q( &_mm512_exp2a23_round_pd($A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_exp2a23_pd);
    eval 'sub _mm512_mask_exp2a23_pd {
        my($W, $U, $A) = @_;
	    eval q( &_mm512_mask_exp2a23_round_pd($W, $U, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_mask_exp2a23_pd);
    eval 'sub _mm512_maskz_exp2a23_pd {
        my($U, $A) = @_;
	    eval q( &_mm512_maskz_exp2a23_round_pd($U, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_maskz_exp2a23_pd);
    eval 'sub _mm512_exp2a23_ps {
        my($A) = @_;
	    eval q( &_mm512_exp2a23_round_ps($A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_exp2a23_ps);
    eval 'sub _mm512_mask_exp2a23_ps {
        my($W, $U, $A) = @_;
	    eval q( &_mm512_mask_exp2a23_round_ps($W, $U, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_mask_exp2a23_ps);
    eval 'sub _mm512_maskz_exp2a23_ps {
        my($U, $A) = @_;
	    eval q( &_mm512_maskz_exp2a23_round_ps($U, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_maskz_exp2a23_ps);
    eval 'sub _mm512_rcp28_pd {
        my($A) = @_;
	    eval q( &_mm512_rcp28_round_pd($A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_rcp28_pd);
    eval 'sub _mm512_mask_rcp28_pd {
        my($W, $U, $A) = @_;
	    eval q( &_mm512_mask_rcp28_round_pd($W, $U, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_mask_rcp28_pd);
    eval 'sub _mm512_maskz_rcp28_pd {
        my($U, $A) = @_;
	    eval q( &_mm512_maskz_rcp28_round_pd($U, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_maskz_rcp28_pd);
    eval 'sub _mm512_rcp28_ps {
        my($A) = @_;
	    eval q( &_mm512_rcp28_round_ps($A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_rcp28_ps);
    eval 'sub _mm512_mask_rcp28_ps {
        my($W, $U, $A) = @_;
	    eval q( &_mm512_mask_rcp28_round_ps($W, $U, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_mask_rcp28_ps);
    eval 'sub _mm512_maskz_rcp28_ps {
        my($U, $A) = @_;
	    eval q( &_mm512_maskz_rcp28_round_ps($U, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_maskz_rcp28_ps);
    eval 'sub _mm512_rsqrt28_pd {
        my($A) = @_;
	    eval q( &_mm512_rsqrt28_round_pd($A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_rsqrt28_pd);
    eval 'sub _mm512_mask_rsqrt28_pd {
        my($W, $U, $A) = @_;
	    eval q( &_mm512_mask_rsqrt28_round_pd($W, $U, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_mask_rsqrt28_pd);
    eval 'sub _mm512_maskz_rsqrt28_pd {
        my($U, $A) = @_;
	    eval q( &_mm512_maskz_rsqrt28_round_pd($U, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_maskz_rsqrt28_pd);
    eval 'sub _mm512_rsqrt28_ps {
        my($A) = @_;
	    eval q( &_mm512_rsqrt28_round_ps($A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_rsqrt28_ps);
    eval 'sub _mm512_mask_rsqrt28_ps {
        my($W, $U, $A) = @_;
	    eval q( &_mm512_mask_rsqrt28_round_ps($W, $U, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_mask_rsqrt28_ps);
    eval 'sub _mm512_maskz_rsqrt28_ps {
        my($U, $A) = @_;
	    eval q( &_mm512_maskz_rsqrt28_round_ps($U, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm512_maskz_rsqrt28_ps);
    eval 'sub _mm_rcp28_sd {
        my($A, $B) = @_;
	    eval q( &__builtin_ia32_rcp28sd_round($B, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm_rcp28_sd);
    eval 'sub _mm_rcp28_ss {
        my($A, $B) = @_;
	    eval q( &__builtin_ia32_rcp28ss_round($B, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm_rcp28_ss);
    eval 'sub _mm_rsqrt28_sd {
        my($A, $B) = @_;
	    eval q( &__builtin_ia32_rsqrt28sd_round($B, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm_rsqrt28_sd);
    eval 'sub _mm_rsqrt28_ss {
        my($A, $B) = @_;
	    eval q( &__builtin_ia32_rsqrt28ss_round($B, $A,  &_MM_FROUND_CUR_DIRECTION));
    }' unless defined(&_mm_rsqrt28_ss);
    if(defined(&__DISABLE_AVX512ER__)) {
	undef(&__DISABLE_AVX512ER__) if defined(&__DISABLE_AVX512ER__);
    }
}
1;
