require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_IMMINTRIN_H_INCLUDED)) {
    die("Never use <avx512vpopcntdqintrin.h> directly; include <x86intrin.h> instead.");
}
unless(defined(&_AVX512VPOPCNTDQINTRIN_H_INCLUDED)) {
    eval 'sub _AVX512VPOPCNTDQINTRIN_H_INCLUDED () {1;}' unless defined(&_AVX512VPOPCNTDQINTRIN_H_INCLUDED);
    unless(defined(&__AVX512VPOPCNTDQ__)) {
	eval 'sub __DISABLE_AVX512VPOPCNTDQ__ () {1;}' unless defined(&__DISABLE_AVX512VPOPCNTDQ__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_popcnt_epi32 ( &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vpopcountd_v16si (( &__v16si)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_popcnt_epi32 ( &__m512i  &__A,  &__mmask16  &__U,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpopcountd_v16si_mask (( &__v16si)  &__A, ( &__v16si)  &__B, ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_popcnt_epi32 ( &__mmask16  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vpopcountd_v16si_mask (( &__v16si)  &__A, ( &__v16si)  &_mm512_setzero_si512 (), ( &__mmask16)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_popcnt_epi64 ( &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vpopcountq_v8di (( &__v8di)  &__A); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_mask_popcnt_epi64 ( &__m512i  &__A,  &__mmask8  &__U,  &__m512i  &__B) { ( &__m512i)  &__builtin_ia32_vpopcountq_v8di_mask (( &__v8di)  &__A, ( &__v8di)  &__B, ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm512_maskz_popcnt_epi64 ( &__mmask8  &__U,  &__m512i  &__A) { ( &__m512i)  &__builtin_ia32_vpopcountq_v8di_mask (( &__v8di)  &__A, ( &__v8di)  &_mm512_setzero_si512 (), ( &__mmask8)  &__U); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_AVX512VPOPCNTDQ__)) {
	undef(&__DISABLE_AVX512VPOPCNTDQ__) if defined(&__DISABLE_AVX512VPOPCNTDQ__);
    }
}
1;
