require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_X86INTRIN_H_INCLUDED)) {
    die("Never use <clwbintrin.h> directly; include <x86intrin.h> instead.");
}
unless(defined(&_CLWBINTRIN_H_INCLUDED)) {
    eval 'sub _CLWBINTRIN_H_INCLUDED () {1;}' unless defined(&_CLWBINTRIN_H_INCLUDED);
    unless(defined(&__CLWB__)) {
	eval 'sub __DISABLE_CLWB__ () {1;}' unless defined(&__DISABLE_CLWB__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_mm_clwb ( &void * &__A) {  &__builtin_ia32_clwb ( &__A); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_CLWB__)) {
	undef(&__DISABLE_CLWB__) if defined(&__DISABLE_CLWB__);
    }
}
1;
