require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86INTRIN_H_INCLUDED)) {
    die("Never use <ia32intrin.h> directly; include <x86intrin.h> instead.");
}
unless(defined(&__iamcu__)) {
    unless(defined(&__SSE4_2__)) {
	eval 'sub __DISABLE_SSE4_2__ () {1;}' unless defined(&__DISABLE_SSE4_2__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__crc32w (my $__C, my $__V) {  &__builtin_ia32_crc32hi ( $__C,  $__V); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &__crc32d (my $__C, my $__V) {  &__builtin_ia32_crc32si ( $__C,  $__V); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_SSE4_2__)) {
	undef(&__DISABLE_SSE4_2__) if defined(&__DISABLE_SSE4_2__);
    }
}
unless(defined(&__iamcu__)) {
}
unless(defined(&__iamcu__)) {
}
if(defined(&__x86_64__)) {
    unless(defined(&__SSE4_2__)) {
	eval 'sub __DISABLE_SSE4_2__ () {1;}' unless defined(&__DISABLE_SSE4_2__);
    }
    if(defined(&__DISABLE_SSE4_2__)) {
	undef(&__DISABLE_SSE4_2__) if defined(&__DISABLE_SSE4_2__);
    }
    eval 'sub _bswap64 {
        my($a) = @_;
	    eval q( &__bswapq($a));
    }' unless defined(&_bswap64);
    eval 'sub _popcnt64 {
        my($a) = @_;
	    eval q( &__popcntq($a));
    }' unless defined(&_popcnt64);
} else {
}
if(defined(&__LP64__)) {
    eval 'sub _lrotl {
        my($a,$b) = @_;
	    eval q( &__rolq(($a), ($b)));
    }' unless defined(&_lrotl);
    eval 'sub _lrotr {
        my($a,$b) = @_;
	    eval q( &__rorq(($a), ($b)));
    }' unless defined(&_lrotr);
} else {
    eval 'sub _lrotl {
        my($a,$b) = @_;
	    eval q( &__rold(($a), ($b)));
    }' unless defined(&_lrotl);
    eval 'sub _lrotr {
        my($a,$b) = @_;
	    eval q( &__rord(($a), ($b)));
    }' unless defined(&_lrotr);
}
eval 'sub _bit_scan_forward {
    my($a) = @_;
	eval q( &__bsfd($a));
}' unless defined(&_bit_scan_forward);
eval 'sub _bit_scan_reverse {
    my($a) = @_;
	eval q( &__bsrd($a));
}' unless defined(&_bit_scan_reverse);
eval 'sub _bswap {
    my($a) = @_;
	eval q( &__bswapd($a));
}' unless defined(&_bswap);
eval 'sub _popcnt32 {
    my($a) = @_;
	eval q( &__popcntd($a));
}' unless defined(&_popcnt32);
unless(defined(&__iamcu__)) {
    eval 'sub _rdpmc {
        my($a) = @_;
	    eval q( &__rdpmc($a));
    }' unless defined(&_rdpmc);
    eval 'sub _rdtscp {
        my($a) = @_;
	    eval q( &__rdtscp($a));
    }' unless defined(&_rdtscp);
}
eval 'sub _rdtsc () {
    eval q( &__rdtsc());
}' unless defined(&_rdtsc);
eval 'sub _rotwl {
    my($a,$b) = @_;
	eval q( &__rolw(($a), ($b)));
}' unless defined(&_rotwl);
eval 'sub _rotwr {
    my($a,$b) = @_;
	eval q( &__rorw(($a), ($b)));
}' unless defined(&_rotwr);
eval 'sub _rotl {
    my($a,$b) = @_;
	eval q( &__rold(($a), ($b)));
}' unless defined(&_rotl);
eval 'sub _rotr {
    my($a,$b) = @_;
	eval q( &__rord(($a), ($b)));
}' unless defined(&_rotr);
1;
