require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_X86INTRIN_H_INCLUDED)) {
    die("Never use <pkuintrin.h> directly; include <x86intrin.h> instead.");
}
unless(defined(&_PKUINTRIN_H_INCLUDED)) {
    eval 'sub _PKUINTRIN_H_INCLUDED () {1;}' unless defined(&_PKUINTRIN_H_INCLUDED);
    unless(defined(&__PKU__)) {
	eval 'sub __DISABLE_PKU__ () {1;}' unless defined(&__DISABLE_PKU__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_rdpkru_u32 ( &void) {  &__builtin_ia32_rdpkru (); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_wrpkru  {  &__builtin_ia32_wrpkru ( &__key); });
    }' unless defined(&__attribute__);
    if(defined(&__DISABLE_PKU__)) {
	undef(&__DISABLE_PKU__) if defined(&__DISABLE_PKU__);
    }
}
1;
