require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_X86INTRIN_H_INCLUDED)) {
    die("Never use <xsavecintrin.h> directly; include <x86intrin.h> instead.");
}
unless(defined(&_XSAVECINTRIN_H_INCLUDED)) {
    eval 'sub _XSAVECINTRIN_H_INCLUDED () {1;}' unless defined(&_XSAVECINTRIN_H_INCLUDED);
    unless(defined(&__XSAVEC__)) {
	eval 'sub __DISABLE_XSAVEC__ () {1;}' unless defined(&__DISABLE_XSAVEC__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xsavec ( &void * &__P, my $__M) {  &__builtin_ia32_xsavec ( &__P,  $__M); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xsavec64 ( &void * &__P, my $__M) {  &__builtin_ia32_xsavec64 ( &__P,  $__M); });
	}' unless defined(&__attribute__);
    }
    if(defined(&__DISABLE_XSAVEC__)) {
	undef(&__DISABLE_XSAVEC__) if defined(&__DISABLE_XSAVEC__);
    }
}
1;
