require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_X86INTRIN_H_INCLUDED)) {
    die("Never use <xsavesintrin.h> directly; include <x86intrin.h> instead.");
}
unless(defined(&_XSAVESINTRIN_H_INCLUDED)) {
    eval 'sub _XSAVESINTRIN_H_INCLUDED () {1;}' unless defined(&_XSAVESINTRIN_H_INCLUDED);
    unless(defined(&__XSAVES__)) {
	eval 'sub __DISABLE_XSAVES__ () {1;}' unless defined(&__DISABLE_XSAVES__);
    }
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xsaves ( &void * &__P, my $__M) {  &__builtin_ia32_xsaves ( &__P,  $__M); });
    }' unless defined(&__attribute__);
    eval 'sub __attribute__ () {
        eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xrstors ( &void * &__P, my $__M) {  &__builtin_ia32_xrstors ( &__P,  $__M); });
    }' unless defined(&__attribute__);
    if(defined(&__x86_64__)) {
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xrstors64 ( &void * &__P, my $__M) {  &__builtin_ia32_xrstors64 ( &__P,  $__M); });
	}' unless defined(&__attribute__);
	eval 'sub __attribute__ () {
	    eval q((( &__gnu_inline__,  &__always_inline__,  &__artificial__))  &_xsaves64 ( &void * &__P, my $__M) {  &__builtin_ia32_xsaves64 ( &__P,  $__M); });
	}' unless defined(&__attribute__);
    }
    if(defined(&__DISABLE_XSAVES__)) {
	undef(&__DISABLE_XSAVES__) if defined(&__DISABLE_XSAVES__);
    }
}
1;
