require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MULTIBOOT_HEADER)) {
    eval 'sub MULTIBOOT_HEADER () {1;}' unless defined(&MULTIBOOT_HEADER);
    eval 'sub MULTIBOOT_SEARCH () {32768;}' unless defined(&MULTIBOOT_SEARCH);
    eval 'sub MULTIBOOT_HEADER_ALIGN () {8;}' unless defined(&MULTIBOOT_HEADER_ALIGN);
    eval 'sub MULTIBOOT2_HEADER_MAGIC () {0xe85250d6;}' unless defined(&MULTIBOOT2_HEADER_MAGIC);
    eval 'sub MULTIBOOT2_BOOTLOADER_MAGIC () {0x36d76289;}' unless defined(&MULTIBOOT2_BOOTLOADER_MAGIC);
    eval 'sub MULTIBOOT_MOD_ALIGN () {0x1000;}' unless defined(&MULTIBOOT_MOD_ALIGN);
    eval 'sub MULTIBOOT_INFO_ALIGN () {0x8;}' unless defined(&MULTIBOOT_INFO_ALIGN);
    eval 'sub MULTIBOOT_TAG_ALIGN () {8;}' unless defined(&MULTIBOOT_TAG_ALIGN);
    eval 'sub MULTIBOOT_TAG_TYPE_END () {0;}' unless defined(&MULTIBOOT_TAG_TYPE_END);
    eval 'sub MULTIBOOT_TAG_TYPE_CMDLINE () {1;}' unless defined(&MULTIBOOT_TAG_TYPE_CMDLINE);
    eval 'sub MULTIBOOT_TAG_TYPE_BOOT_LOADER_NAME () {2;}' unless defined(&MULTIBOOT_TAG_TYPE_BOOT_LOADER_NAME);
    eval 'sub MULTIBOOT_TAG_TYPE_MODULE () {3;}' unless defined(&MULTIBOOT_TAG_TYPE_MODULE);
    eval 'sub MULTIBOOT_TAG_TYPE_BASIC_MEMINFO () {4;}' unless defined(&MULTIBOOT_TAG_TYPE_BASIC_MEMINFO);
    eval 'sub MULTIBOOT_TAG_TYPE_BOOTDEV () {5;}' unless defined(&MULTIBOOT_TAG_TYPE_BOOTDEV);
    eval 'sub MULTIBOOT_TAG_TYPE_MMAP () {6;}' unless defined(&MULTIBOOT_TAG_TYPE_MMAP);
    eval 'sub MULTIBOOT_TAG_TYPE_VBE () {7;}' unless defined(&MULTIBOOT_TAG_TYPE_VBE);
    eval 'sub MULTIBOOT_TAG_TYPE_FRAMEBUFFER () {8;}' unless defined(&MULTIBOOT_TAG_TYPE_FRAMEBUFFER);
    eval 'sub MULTIBOOT_TAG_TYPE_ELF_SECTIONS () {9;}' unless defined(&MULTIBOOT_TAG_TYPE_ELF_SECTIONS);
    eval 'sub MULTIBOOT_TAG_TYPE_APM () {10;}' unless defined(&MULTIBOOT_TAG_TYPE_APM);
    eval 'sub MULTIBOOT_TAG_TYPE_EFI32 () {11;}' unless defined(&MULTIBOOT_TAG_TYPE_EFI32);
    eval 'sub MULTIBOOT_TAG_TYPE_EFI64 () {12;}' unless defined(&MULTIBOOT_TAG_TYPE_EFI64);
    eval 'sub MULTIBOOT_TAG_TYPE_SMBIOS () {13;}' unless defined(&MULTIBOOT_TAG_TYPE_SMBIOS);
    eval 'sub MULTIBOOT_TAG_TYPE_ACPI_OLD () {14;}' unless defined(&MULTIBOOT_TAG_TYPE_ACPI_OLD);
    eval 'sub MULTIBOOT_TAG_TYPE_ACPI_NEW () {15;}' unless defined(&MULTIBOOT_TAG_TYPE_ACPI_NEW);
    eval 'sub MULTIBOOT_TAG_TYPE_NETWORK () {16;}' unless defined(&MULTIBOOT_TAG_TYPE_NETWORK);
    eval 'sub MULTIBOOT_TAG_TYPE_EFI_MMAP () {17;}' unless defined(&MULTIBOOT_TAG_TYPE_EFI_MMAP);
    eval 'sub MULTIBOOT_TAG_TYPE_EFI_BS () {18;}' unless defined(&MULTIBOOT_TAG_TYPE_EFI_BS);
    eval 'sub MULTIBOOT_TAG_TYPE_EFI32_IH () {19;}' unless defined(&MULTIBOOT_TAG_TYPE_EFI32_IH);
    eval 'sub MULTIBOOT_TAG_TYPE_EFI64_IH () {20;}' unless defined(&MULTIBOOT_TAG_TYPE_EFI64_IH);
    eval 'sub MULTIBOOT_TAG_TYPE_LOAD_BASE_ADDR () {21;}' unless defined(&MULTIBOOT_TAG_TYPE_LOAD_BASE_ADDR);
    eval 'sub MULTIBOOT_HEADER_TAG_END () {0;}' unless defined(&MULTIBOOT_HEADER_TAG_END);
    eval 'sub MULTIBOOT_HEADER_TAG_INFORMATION_REQUEST () {1;}' unless defined(&MULTIBOOT_HEADER_TAG_INFORMATION_REQUEST);
    eval 'sub MULTIBOOT_HEADER_TAG_ADDRESS () {2;}' unless defined(&MULTIBOOT_HEADER_TAG_ADDRESS);
    eval 'sub MULTIBOOT_HEADER_TAG_ENTRY_ADDRESS () {3;}' unless defined(&MULTIBOOT_HEADER_TAG_ENTRY_ADDRESS);
    eval 'sub MULTIBOOT_HEADER_TAG_CONSOLE_FLAGS () {4;}' unless defined(&MULTIBOOT_HEADER_TAG_CONSOLE_FLAGS);
    eval 'sub MULTIBOOT_HEADER_TAG_FRAMEBUFFER () {5;}' unless defined(&MULTIBOOT_HEADER_TAG_FRAMEBUFFER);
    eval 'sub MULTIBOOT_HEADER_TAG_MODULE_ALIGN () {6;}' unless defined(&MULTIBOOT_HEADER_TAG_MODULE_ALIGN);
    eval 'sub MULTIBOOT_HEADER_TAG_EFI_BS () {7;}' unless defined(&MULTIBOOT_HEADER_TAG_EFI_BS);
    eval 'sub MULTIBOOT_HEADER_TAG_ENTRY_ADDRESS_EFI32 () {8;}' unless defined(&MULTIBOOT_HEADER_TAG_ENTRY_ADDRESS_EFI32);
    eval 'sub MULTIBOOT_HEADER_TAG_ENTRY_ADDRESS_EFI64 () {9;}' unless defined(&MULTIBOOT_HEADER_TAG_ENTRY_ADDRESS_EFI64);
    eval 'sub MULTIBOOT_HEADER_TAG_RELOCATABLE () {10;}' unless defined(&MULTIBOOT_HEADER_TAG_RELOCATABLE);
    eval 'sub MULTIBOOT_ARCHITECTURE_I386 () {0;}' unless defined(&MULTIBOOT_ARCHITECTURE_I386);
    eval 'sub MULTIBOOT_ARCHITECTURE_MIPS32 () {4;}' unless defined(&MULTIBOOT_ARCHITECTURE_MIPS32);
    eval 'sub MULTIBOOT_HEADER_TAG_OPTIONAL () {1;}' unless defined(&MULTIBOOT_HEADER_TAG_OPTIONAL);
    eval 'sub MULTIBOOT_LOAD_PREFERENCE_NONE () {0;}' unless defined(&MULTIBOOT_LOAD_PREFERENCE_NONE);
    eval 'sub MULTIBOOT_LOAD_PREFERENCE_LOW () {1;}' unless defined(&MULTIBOOT_LOAD_PREFERENCE_LOW);
    eval 'sub MULTIBOOT_LOAD_PREFERENCE_HIGH () {2;}' unless defined(&MULTIBOOT_LOAD_PREFERENCE_HIGH);
    eval 'sub MULTIBOOT_CONSOLE_FLAGS_CONSOLE_REQUIRED () {1;}' unless defined(&MULTIBOOT_CONSOLE_FLAGS_CONSOLE_REQUIRED);
    eval 'sub MULTIBOOT_CONSOLE_FLAGS_EGA_TEXT_SUPPORTED () {2;}' unless defined(&MULTIBOOT_CONSOLE_FLAGS_EGA_TEXT_SUPPORTED);
    unless(defined(&ASM_FILE)) {
	eval 'sub MULTIBOOT_MEMORY_AVAILABLE () {1;}' unless defined(&MULTIBOOT_MEMORY_AVAILABLE);
	eval 'sub MULTIBOOT_MEMORY_RESERVED () {2;}' unless defined(&MULTIBOOT_MEMORY_RESERVED);
	eval 'sub MULTIBOOT_MEMORY_ACPI_RECLAIMABLE () {3;}' unless defined(&MULTIBOOT_MEMORY_ACPI_RECLAIMABLE);
	eval 'sub MULTIBOOT_MEMORY_NVS () {4;}' unless defined(&MULTIBOOT_MEMORY_NVS);
	eval 'sub MULTIBOOT_MEMORY_BADRAM () {5;}' unless defined(&MULTIBOOT_MEMORY_BADRAM);
	eval 'sub MULTIBOOT_FRAMEBUFFER_TYPE_INDEXED () {0;}' unless defined(&MULTIBOOT_FRAMEBUFFER_TYPE_INDEXED);
	eval 'sub MULTIBOOT_FRAMEBUFFER_TYPE_RGB () {1;}' unless defined(&MULTIBOOT_FRAMEBUFFER_TYPE_RGB);
	eval 'sub MULTIBOOT_FRAMEBUFFER_TYPE_EGA_TEXT () {2;}' unless defined(&MULTIBOOT_FRAMEBUFFER_TYPE_EGA_TEXT);
    }
}
1;
