require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&_KERNEL)) {
    require 'machine/cpufunc.ph';
}
eval 'sub _MCOUNT_DECL () { &static  &__inline  &void  &_mcount;}' unless defined(&_MCOUNT_DECL);
if(defined(&__ELF__)) {
    eval 'sub MCOUNT_ENTRY () {"__mcount";}' unless defined(&MCOUNT_ENTRY);
    eval 'sub MCOUNT_COMPAT () { &__weak_alias( &mcount,  &__mcount);}' unless defined(&MCOUNT_COMPAT);
} else {
    eval 'sub MCOUNT_ENTRY () {"mcount";}' unless defined(&MCOUNT_ENTRY);
    eval 'sub MCOUNT_COMPAT () {1;}' unless defined(&MCOUNT_COMPAT);
}
if(defined(&_REENTRANT)  && !defined(&_KERNEL) ) {
    eval 'sub MCOUNT_ACTIVE () { &if ( ($_gmonparam->{state}) !=  &GMON_PROF_ON)  &return;}' unless defined(&MCOUNT_ACTIVE);
} else {
    eval 'sub MCOUNT_ACTIVE () {1;}' unless defined(&MCOUNT_ACTIVE);
}
eval 'sub MCOUNT () { &MCOUNT_COMPAT  &extern  &void  &mcount( &void)  &__asm( &MCOUNT_ENTRY)  &__attribute__();  &void  &mcount { \'int\'  &selfpc,  &frompcindex; \'int\'  &eax,  &ecx,  &edx;  &MCOUNT_ACTIVE;  &__asm  &volatile("movl %%eax,%0" : "=g" );  &__asm  &volatile("movl %%ecx,%0" : "=g" );  &__asm  &volatile("movl %%edx,%0" : "=g" );  &selfpc =  &__builtin_return_address;  &frompcindex = [1];  &_mcount( &frompcindex,  &selfpc);  &__asm  &volatile("movl %0,%%edx" : : "g" ( &edx));  &__asm  &volatile("movl %0,%%ecx" : : "g" ( &ecx));  &__asm  &volatile("movl %0,%%eax" : : "g" ( &eax)); };}' unless defined(&MCOUNT);
if(defined(&_KERNEL)) {
    eval 'sub mcount_disable_intr {
        my($void) = @_;
	    eval q({  &__asm  &volatile(\\"cli\\"); });
    }' unless defined(&mcount_disable_intr);
    eval 'sub mcount_read_psl {
        my($void) = @_;
	    eval q({ my $ef;  &__asm  &volatile(\\"pushfl; popl %0\\" : \\"=r\\" ( $ef)); ( $ef); });
    }' unless defined(&mcount_read_psl);
    eval 'sub mcount_write_psl {
        my($ef) = @_;
	    eval q({  &__asm  &volatile(\\"pushl %0; popfl\\" : : \\"r\\" ($ef)); });
    }' unless defined(&mcount_write_psl);
    eval 'sub MCOUNT_ENTER () { &do {  &s =  &mcount_read_psl();  &mcount_disable_intr(); }  &while (0);}' unless defined(&MCOUNT_ENTER);
    eval 'sub MCOUNT_EXIT () { &do {  &mcount_write_psl( &s); }  &while (0);}' unless defined(&MCOUNT_EXIT);
}
1;
