require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_I386_PTE_H_)) {
    eval 'sub _I386_PTE_H_ () {1;}' unless defined(&_I386_PTE_H_);
    if(defined(&_KERNEL_OPT)) {
	require './i386/opt_xen.ph';
    }
    if(!defined(&_LOCORE)) {
	if(defined(&PAE)) {
	} else {
	}
    }
    if(defined(&PAE)) {
	eval 'sub L1_SHIFT () {12;}' unless defined(&L1_SHIFT);
	eval 'sub L2_SHIFT () {21;}' unless defined(&L2_SHIFT);
	eval 'sub L3_SHIFT () {30;}' unless defined(&L3_SHIFT);
	eval 'sub NBPD_L1 () {(1 <<  &L1_SHIFT);}' unless defined(&NBPD_L1);
	eval 'sub NBPD_L2 () {(1 <<  &L2_SHIFT);}' unless defined(&NBPD_L2);
	eval 'sub NBPD_L3 () {(1 <<  &L3_SHIFT);}' unless defined(&NBPD_L3);
	eval 'sub L3_MASK () {0xc0000000;}' unless defined(&L3_MASK);
	eval 'sub L2_REALMASK () {0x3fe00000;}' unless defined(&L2_REALMASK);
	eval 'sub L2_MASK () {( &L2_REALMASK |  &L3_MASK);}' unless defined(&L2_MASK);
	eval 'sub L1_MASK () {0x1ff000;}' unless defined(&L1_MASK);
	eval 'sub L3_FRAME () {( &L3_MASK);}' unless defined(&L3_FRAME);
	eval 'sub L2_FRAME () {( &L3_FRAME |  &L2_MASK);}' unless defined(&L2_FRAME);
	eval 'sub L1_FRAME () {( &L2_FRAME| &L1_MASK);}' unless defined(&L1_FRAME);
	eval 'sub PG_FRAME () {4.5035996273664e+15;}' unless defined(&PG_FRAME);
	eval 'sub PG_LGFRAME () {4.50359962527334e+15;}' unless defined(&PG_LGFRAME);
	eval 'sub PTE_4KFRAME () {4.5035996273664e+15;}' unless defined(&PTE_4KFRAME);
	eval 'sub PTE_2MFRAME () {4.50359962527334e+15;}' unless defined(&PTE_2MFRAME);
	eval 'sub PTE_FRAME () { &PTE_4KFRAME;}' unless defined(&PTE_FRAME);
	eval 'sub PTE_LGFRAME () { &PTE_2MFRAME;}' unless defined(&PTE_LGFRAME);
	eval 'sub l2tol3 {
	    my($idx) = @_;
    	    eval q((($idx) >> ( &L3_SHIFT -  &L2_SHIFT)));
	}' unless defined(&l2tol3);
	eval 'sub l2tol2 {
	    my($idx) = @_;
    	    eval q((($idx) & ( &L2_REALMASK >>  &L2_SHIFT)));
	}' unless defined(&l2tol2);
    } else {
	eval 'sub L1_SHIFT () {12;}' unless defined(&L1_SHIFT);
	eval 'sub L2_SHIFT () {22;}' unless defined(&L2_SHIFT);
	eval 'sub NBPD_L1 () {(1 <<  &L1_SHIFT);}' unless defined(&NBPD_L1);
	eval 'sub NBPD_L2 () {(1 <<  &L2_SHIFT);}' unless defined(&NBPD_L2);
	eval 'sub L2_MASK () {0xffc00000;}' unless defined(&L2_MASK);
	eval 'sub L1_MASK () {0x3ff000;}' unless defined(&L1_MASK);
	eval 'sub L2_FRAME () {( &L2_MASK);}' unless defined(&L2_FRAME);
	eval 'sub L1_FRAME () {( &L2_FRAME| &L1_MASK);}' unless defined(&L1_FRAME);
	eval 'sub PG_FRAME () {0xfffff000;}' unless defined(&PG_FRAME);
	eval 'sub PG_LGFRAME () {0xffc00000;}' unless defined(&PG_LGFRAME);
	eval 'sub PTE_4KFRAME () {0xfffff000;}' unless defined(&PTE_4KFRAME);
	eval 'sub PTE_4MFRAME () {0xffc00000;}' unless defined(&PTE_4MFRAME);
	eval 'sub PTE_FRAME () { &PTE_4KFRAME;}' unless defined(&PTE_FRAME);
	eval 'sub PTE_LGFRAME () { &PTE_4MFRAME;}' unless defined(&PTE_LGFRAME);
    }
    eval 'sub PTE_P () {0x1;}' unless defined(&PTE_P);
    eval 'sub PTE_W () {0x2;}' unless defined(&PTE_W);
    eval 'sub PTE_U () {0x4;}' unless defined(&PTE_U);
    eval 'sub PTE_PWT () {0x8;}' unless defined(&PTE_PWT);
    eval 'sub PTE_PCD () {0x10;}' unless defined(&PTE_PCD);
    eval 'sub PTE_A () {0x20;}' unless defined(&PTE_A);
    eval 'sub PTE_D () {0x40;}' unless defined(&PTE_D);
    eval 'sub PTE_PAT () {0x80;}' unless defined(&PTE_PAT);
    eval 'sub PTE_PS () {0x80;}' unless defined(&PTE_PS);
    eval 'sub PTE_G () {0x100;}' unless defined(&PTE_G);
    eval 'sub PTE_AVL1 () {0x200;}' unless defined(&PTE_AVL1);
    eval 'sub PTE_AVL2 () {0x400;}' unless defined(&PTE_AVL2);
    eval 'sub PTE_AVL3 () {0x800;}' unless defined(&PTE_AVL3);
    eval 'sub PTE_LGPAT () {0x1000;}' unless defined(&PTE_LGPAT);
    if(defined(&PAE)) {
	eval 'sub PTE_NX () {9.22337203685478e+18;}' unless defined(&PTE_NX);
    } else {
	eval 'sub PTE_NX () {0;}' unless defined(&PTE_NX);
    }
    eval 'sub PG_V () { &PTE_P;}' unless defined(&PG_V);
    eval 'sub PG_RW () { &PTE_W;}' unless defined(&PG_RW);
    eval 'sub PG_u () { &PTE_U;}' unless defined(&PG_u);
    eval 'sub PG_WT () { &PTE_PWT;}' unless defined(&PG_WT);
    eval 'sub PG_N () { &PTE_PCD;}' unless defined(&PG_N);
    eval 'sub PG_U () { &PTE_A;}' unless defined(&PG_U);
    eval 'sub PG_M () { &PTE_D;}' unless defined(&PG_M);
    eval 'sub PG_PAT () { &PTE_PAT;}' unless defined(&PG_PAT);
    eval 'sub PG_PS () { &PTE_PS;}' unless defined(&PG_PS);
    eval 'sub PG_G () { &PTE_G;}' unless defined(&PG_G);
    eval 'sub PG_AVAIL1 () { &PTE_AVL1;}' unless defined(&PG_AVAIL1);
    eval 'sub PG_AVAIL2 () { &PTE_AVL2;}' unless defined(&PG_AVAIL2);
    eval 'sub PG_AVAIL3 () { &PTE_AVL3;}' unless defined(&PG_AVAIL3);
    eval 'sub PG_LGPAT () { &PTE_LGPAT;}' unless defined(&PG_LGPAT);
    eval 'sub PG_KW () { &PTE_W;}' unless defined(&PG_KW);
    eval 'sub PG_NX () { &PTE_NX;}' unless defined(&PG_NX);
    require 'x86/pte.ph';
}
1;
