require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_INTRDEFS_H_)) {
    eval 'sub _X86_INTRDEFS_H_ () {1;}' unless defined(&_X86_INTRDEFS_H_);
    eval 'sub IPL_NONE () {0x;}' unless defined(&IPL_NONE);
    eval 'sub IPL_PREEMPT () {0x1;}' unless defined(&IPL_PREEMPT);
    eval 'sub IPL_SOFTCLOCK () {0x2;}' unless defined(&IPL_SOFTCLOCK);
    eval 'sub IPL_SOFTBIO () {0x3;}' unless defined(&IPL_SOFTBIO);
    eval 'sub IPL_SOFTNET () {0x4;}' unless defined(&IPL_SOFTNET);
    eval 'sub IPL_SOFTSERIAL () {0x5;}' unless defined(&IPL_SOFTSERIAL);
    eval 'sub IPL_VM () {0x6;}' unless defined(&IPL_VM);
    eval 'sub IPL_SCHED () {0x7;}' unless defined(&IPL_SCHED);
    eval 'sub IPL_HIGH () {0x8;}' unless defined(&IPL_HIGH);
    eval 'sub NIPL () {9;}' unless defined(&NIPL);
    eval 'sub IST_NONE () {0;}' unless defined(&IST_NONE);
    eval 'sub IST_PULSE () {1;}' unless defined(&IST_PULSE);
    eval 'sub IST_EDGE () {2;}' unless defined(&IST_EDGE);
    eval 'sub IST_LEVEL () {3;}' unless defined(&IST_LEVEL);
    eval 'sub LIR_IPI () {31;}' unless defined(&LIR_IPI);
    eval 'sub LIR_TIMER () {30;}' unless defined(&LIR_TIMER);
    eval 'sub LIR_HV () {29;}' unless defined(&LIR_HV);
    eval 'sub SIR_SERIAL () {28;}' unless defined(&SIR_SERIAL);
    eval 'sub SIR_NET () {27;}' unless defined(&SIR_NET);
    eval 'sub SIR_BIO () {26;}' unless defined(&SIR_BIO);
    eval 'sub SIR_CLOCK () {25;}' unless defined(&SIR_CLOCK);
    eval 'sub SIR_PREEMPT () {24;}' unless defined(&SIR_PREEMPT);
    eval 'sub MAX_INTR_SOURCES () {32;}' unless defined(&MAX_INTR_SOURCES);
    eval 'sub NUM_LEGACY_IRQS () {16;}' unless defined(&NUM_LEGACY_IRQS);
    eval 'sub IDT_INTR_LOW () {(0x20 +  &NUM_LEGACY_IRQS);}' unless defined(&IDT_INTR_LOW);
    eval 'sub IDT_INTR_HIGH () {0xef;}' unless defined(&IDT_INTR_HIGH);
    unless(defined(&XENPV)) {
	eval 'sub X86_IPI_HALT () {0x1;}' unless defined(&X86_IPI_HALT);
	eval 'sub X86_IPI_MICROSET () {0x2;}' unless defined(&X86_IPI_MICROSET);
	eval 'sub X86_IPI_GENERIC () {0x4;}' unless defined(&X86_IPI_GENERIC);
	eval 'sub X86_IPI_SYNCH_FPU () {0x8;}' unless defined(&X86_IPI_SYNCH_FPU);
	eval 'sub X86_IPI_MTRR () {0x10;}' unless defined(&X86_IPI_MTRR);
	eval 'sub X86_IPI_GDT () {0x20;}' unless defined(&X86_IPI_GDT);
	eval 'sub X86_IPI_XCALL () {0x40;}' unless defined(&X86_IPI_XCALL);
	eval 'sub X86_IPI_ACPI_CPU_SLEEP () {0x80;}' unless defined(&X86_IPI_ACPI_CPU_SLEEP);
	eval 'sub X86_IPI_KPREEMPT () {0x100;}' unless defined(&X86_IPI_KPREEMPT);
	eval 'sub X86_NIPI () {9;}' unless defined(&X86_NIPI);
	eval 'sub X86_IPI_NAMES () {{ "halt IPI", "timeset IPI", "generic IPI", "FPU synch IPI", "MTRR update IPI", "GDT update IPI", "xcall IPI", "ACPI CPU sleep IPI", "kpreempt IPI" };}' unless defined(&X86_IPI_NAMES);
    }
    eval 'sub IREENT_MAGIC () {0x18041969;}' unless defined(&IREENT_MAGIC);
}
1;
