require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_X86_VIA_PADLOCK_H_)) {
    eval 'sub _X86_VIA_PADLOCK_H_ () {1;}' unless defined(&_X86_VIA_PADLOCK_H_);
    if(defined(&_KERNEL)) {
	require 'sys/rndsource.ph';
	require 'sys/callout.ph';
	require 'crypto/rijndael/rijndael.ph';
	eval 'sub C3_CRYPT_CWLO_ROUND_M () {0xf;}' unless defined(&C3_CRYPT_CWLO_ROUND_M);
	eval 'sub C3_CRYPT_CWLO_ALG_M () {0x70;}' unless defined(&C3_CRYPT_CWLO_ALG_M);
	eval 'sub C3_CRYPT_CWLO_ALG_AES () {0x;}' unless defined(&C3_CRYPT_CWLO_ALG_AES);
	eval 'sub C3_CRYPT_CWLO_KEYGEN_M () {0x80;}' unless defined(&C3_CRYPT_CWLO_KEYGEN_M);
	eval 'sub C3_CRYPT_CWLO_KEYGEN_HW () {0x;}' unless defined(&C3_CRYPT_CWLO_KEYGEN_HW);
	eval 'sub C3_CRYPT_CWLO_KEYGEN_SW () {0x80;}' unless defined(&C3_CRYPT_CWLO_KEYGEN_SW);
	eval 'sub C3_CRYPT_CWLO_NORMAL () {0x;}' unless defined(&C3_CRYPT_CWLO_NORMAL);
	eval 'sub C3_CRYPT_CWLO_INTERMEDIATE () {0x100;}' unless defined(&C3_CRYPT_CWLO_INTERMEDIATE);
	eval 'sub C3_CRYPT_CWLO_ENCRYPT () {0x;}' unless defined(&C3_CRYPT_CWLO_ENCRYPT);
	eval 'sub C3_CRYPT_CWLO_DECRYPT () {0x200;}' unless defined(&C3_CRYPT_CWLO_DECRYPT);
	eval 'sub C3_CRYPT_CWLO_KEY128 () {0xa;}' unless defined(&C3_CRYPT_CWLO_KEY128);
	eval 'sub C3_CRYPT_CWLO_KEY192 () {0x40c;}' unless defined(&C3_CRYPT_CWLO_KEY192);
	eval 'sub C3_CRYPT_CWLO_KEY256 () {0x80e;}' unless defined(&C3_CRYPT_CWLO_KEY256);
	eval 'sub VIAC3_SESSION {
	    my($sid) = @_;
    	    eval q((($sid) & 0xfffffff));
	}' unless defined(&VIAC3_SESSION);
	eval 'sub VIAC3_SID {
	    my($crd,$ses) = @_;
    	    eval q(((($crd) << 28) | (($ses) & 0xfffffff)));
	}' unless defined(&VIAC3_SID);
    }
    if(defined(&_KERNEL) || defined(&_KMEMUSER)) {
    }
}
1;
